import 'package:flutter/services.dart';
import 'package:gprs_convert/gprs_convert.dart';
import 'package:gprs_convert/protocol/login_request.dart';
import 'package:gprs_convert/protocol/login_response.dart';
import 'package:gprs_convert/protocol/query_request.dart';
import 'package:gprs_convert/protocol/query_response.dart';
import 'package:xdja_bridge/xdja_bridge.dart';
import 'global.dart';

Future<LoginResponse> loginTest() async {
  // String request = '''<?xml version="1.0" encoding="UTF-8"?><Root><ReqType>req_jtgl_zdgx</ReqType><SessionID>0093330900288442470</SessionID><BeginNo>1</BeginNo><DataSource>1</DataSource><Condition><c_dbname>jtglzd.db</c_dbname><c_date Type='1' Relation='9'>20200831235914</c_date></Condition></Root>''';
  var loginResponse;
  try {
    var loginRequest = LoginRequest();
    loginRequest.reqType = 'login';
    loginRequest.validateType = billType;
    loginRequest.validateValue = await Bridge.uaacToken;
    loginRequest.currentVersion = await Bridge.platformVersion;
    loginRequest.clientType = 'Android';
    loginRequest.cardType = '3';
    loginRequest.iccid = await Bridge.safeCardId;
    // var request = loginRequest.buildXml();
    var request = GprsConvert.convertToXml(loginRequest);
    print('request:$request');
    var response =
        await Bridge.gprsServerRequest("192.168.20.152", "2003", request);
    print('response:$response');
    // loginResponse = LoginResponse.parseXml(response);
    loginResponse = GprsConvert.parseXml(response, LoginResponse());
    Globals.loginResponse = loginResponse;
  } on PlatformException catch (e, s) {
    print('Stack trace:\n ${e.message}');
  }
  return loginResponse;
}

Future<QueryResponse> queryTest() async {
  QueryResponse queryResponse;
  try {
    QueryRequest queryRequest = QueryRequest();
    queryRequest.appKey = '123';
    queryRequest.reqDigest = '交通管理';
    queryRequest.sessionID = Globals.loginResponse?.sessionID;
    queryRequest.beginNo = '1';
    // queryRequest.reqType = 'zhcx_czrk';
    // queryRequest.addCondition('c_xm', '李刚',
    // relation: RelationCharExpression.rightLike);
    queryRequest.reqType = 'dxcx_czrk';
    queryRequest.addCondition('c_sfzh', '410185198701281039');
    // var request = queryRequest.buildXml();
    var request = GprsConvert.convertToXml(queryRequest);
    print('request:$request');
    var response =
        await Bridge.gprsServerRequest("192.168.20.152", "2003", request);
    // var response = await rootBundle.loadString('data/query_response.xml');
    print('response:$response');
    // var queryRespon = QueryResponse.parseXml(response);
    queryResponse = GprsConvert.parseXml(response, QueryResponse());
    print(queryResponse.type);
  } on PlatformException catch (e, s) {
    print('Stack trace:\n ${e.message}');
  }
  return queryResponse;
}
