import 'package:flutter/services.dart';

import 'protocol/base_protocol/base_request.dart';
import 'protocol/base_protocol/base_response.dart';

class GprsConvert {
  static const MethodChannel _channel = const MethodChannel('gprs_convert');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }
  
  static String convertToXml<Request extends BaseRequest>(Request request) {
    return request.buildXml();
  }

  static Response parseXml<Response extends BaseResponse>(
      String response, Response responseType) {
    return responseType.parseXml(response);
  }
}
